//////////////////////////////////////////////////////////////////////////////////////
//                    Principales fonctions graphiques															//
//////////////////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////////////

// La fonction 'dissolve_LCD' a t cre par Thomas Nussbaumer (TICT) et j'en me suis
// inspir pour crer la fonction 'dissolve_SPRITE'.


void dissolve_LCD (unsigned char *lcd_0, unsigned char *lcd_1)
{
  unsigned short seq = 1;
  unsigned char pixmask;
  unsigned short byteoffset;

  do
  {
  	pixmask = seq & 0x7;
    byteoffset = seq >> 3;
    
    if(byteoffset < LCD_SIZE)
    {
    	pixmask = 0x80 >> pixmask;
    	
    	if(*(unsigned char*)(lcd_0+byteoffset) & pixmask)
    	{
    		*(unsigned char*)(plan0+byteoffset) |= pixmask;
    	}
    	else
    	{
    		*(unsigned char*)(plan0+byteoffset) &= ~pixmask;
    	}
    	
    	if(*(unsigned char*)(lcd_1+byteoffset) & pixmask)
    	{
    		*(unsigned char*)(plan1+byteoffset) |= pixmask;
    	}
    	else
    	{
    		*(unsigned char*)(plan1+byteoffset) &= ~pixmask;
    	}
    	
    }
    
    if(seq & 1)
    {
    	seq = (seq >> 1) ^ 0x6000;
    }
    else
    {
    	seq = seq >> 1;
    }
      
  }while(seq != 1);

}

//////////////////////////////////////////////////////////////////////////////////////

void dissolve_SPRITE(unsigned char *sprite_0, unsigned char *sprite_1)
{
  unsigned short seq = 1;
  unsigned char pixmask;
  unsigned short byteoffset;

  do
  {
  	pixmask = seq & 0x7;
    byteoffset = seq >> 3;
    
    if(byteoffset < 2000)
    {
    	pixmask = 0x80 >> pixmask;
    	
    	if(*(unsigned char*)(sprite_0+byteoffset) & pixmask)
    	{
    		*(unsigned char*)(plan0+ADAPT_y*30+ADAPT_x/8+30*(byteoffset/20)+byteoffset%20) |= pixmask;
    	}
    	else
    	{
    		*(unsigned char*)(plan0+ADAPT_y*30+ADAPT_x/8+30*(byteoffset/20)+byteoffset%20) &= ~pixmask;
    	}
    	
    	if(*(unsigned char*)(sprite_1+byteoffset) & pixmask)
    	{
    		*(unsigned char*)(plan1+ADAPT_y*30+ADAPT_x/8+30*(byteoffset/20)+byteoffset%20) |= pixmask;
    	}
    	else
    	{
    		*(unsigned char*)(plan1+ADAPT_y*30+ADAPT_x/8+30*(byteoffset/20)+byteoffset%20) &= ~pixmask;
    	}
    	
    }
    
    if(seq & 1)
    {
    	seq = (seq >> 1) ^ 0x6000;
    }
    else
    {
    	seq = seq >> 1;
    }

  }while(seq != 1);

}

//////////////////////////////////////////////////////////////////////////////////////

void sauve_pic(char *buffer)
{
	memcpy(buffer, plan0, LCD_SIZE);
	memcpy(buffer+LCD_SIZE, plan1, LCD_SIZE);	
}

//////////////////////////////////////////////////////////////////////////////////////

void restaure_pic(char *buffer)
{
	memcpy(plan0, buffer, LCD_SIZE);
	memcpy(plan1, buffer+LCD_SIZE, LCD_SIZE);
}

//////////////////////////////////////////////////////////////////////////////////////

void bitmap_put(short x, short y, char *bitmap, short mode, short plan)
{
	SetPlane(plan);
	BitmapPut(ADAPT_x+x, ADAPT_y+y, bitmap, &ecran, mode);	
}

//////////////////////////////////////////////////////////////////////////////////////

void sprite8_GRIS(short x, short y, unsigned char *sprite1, unsigned char *sprite2)
{
	Sprite8(ADAPT_x+x, ADAPT_y+y, 8, sprite1, plan0, SPRT_XOR);
	Sprite8(ADAPT_x+x, ADAPT_y+y, 8, sprite2, plan1, SPRT_XOR);
}

//////////////////////////////////////////////////////////////////////////////////////

void sprite16_GRIS(short x, short y, unsigned short *sprite1, unsigned short *sprite2)
{
	Sprite16(ADAPT_x+x, ADAPT_y+y, 16, sprite1, plan0, SPRT_XOR);
	Sprite16(ADAPT_x+x, ADAPT_y+y, 16, sprite2, plan1, SPRT_XOR);
}

//////////////////////////////////////////////////////////////////////////////////////

void draw_rect(short x1, short y1, short x2, short y2, short mode, short plan)
{
	SetPlane(plan);
	DrawClipRect(MakeWinRect(ADAPT_x+x1, ADAPT_y+y1, ADAPT_x+x2, ADAPT_y+y2), &ecran, mode);	
}

//////////////////////////////////////////////////////////////////////////////////////

void fill_rect(short x1, short y1, short x2, short y2, short mode, short plan)
{
	SCR_RECT rect = {{ADAPT_x+x1, ADAPT_y+y1, ADAPT_x+x2, ADAPT_y+y2}};
	SetPlane(plan);
	ScrRectFill(&rect, &ecran, mode);	
}

//////////////////////////////////////////////////////////////////////////////////////

void clr_plans(void)
{
	fill_rect(0, 0, 159, 99, 0, GRIS_CLAIR);
	fill_rect(0, 0, 159, 99, 0, GRIS_FONCE);
}

//////////////////////////////////////////////////////////////////////////////////////

void draw_line(short x1, short y1, short x2, short y2, short mode, short plan)
{
	SetPlane(plan);
	DrawLine(ADAPT_x+x1, ADAPT_y+y1, ADAPT_x+x2, ADAPT_y+y2, mode);
}

//////////////////////////////////////////////////////////////////////////////////////

void draw_str(short x, short y, const char *str, short mode, short plan,
short taille)
{
	SetPlane(plan);
	FontSetSys(taille);
	DrawStr(ADAPT_x+x, ADAPT_y+y, str, mode);
}

//////////////////////////////////////////////////////////////////////////////////////

void draw_num(short x, short y, const char *str, unsigned short num, short mode,
short plan, short taille)
{
  char buffer[20];
  
  sprintf(buffer, str, num);
  draw_str(x, y, buffer, mode, plan, taille);
}

//////////////////////////////////////////////////////////////////////////////////////